﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TravelCompanyContracts.BindingModels.OperatorBindingModels;
using TravelCompanyContracts.ViewModels.OperatorViewModels;
using TravelCompanyDataModels.Models.OperatorModels;

namespace TravelCompanyDatabaseImplement.Models
{
    public class Tour : ITourModel
    {
        public int Id { get; set; }
        [Required]
        public string TourName { get; set; } = string.Empty;
        [Required]
        public int TouristId { get; private set; }

        public virtual Tourist Tourist { get; set; }
        public static Tour? Create(TravelCompanyDatabase context, TourBindingModel model)
        {
            if (model == null)
            {
                return null;
            }
            return new Tour()
            {
                Id = model.Id,
                TourName = model.TourName
            };
        }

        public TourViewModel GetViewModel => new()
        {
            Id = Id,
            TourName = TourName,
            OperatorId = TouristId
        };
    }
}